#ifndef _H_34E919BC97A4DF99DFF64B66078FE6C9_ConnectedClients_DCPS_H_
#define _H_34E919BC97A4DF99DFF64B66078FE6C9_ConnectedClients_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ConnectedClients_.h"


namespace rosbridge_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ConnectedClients_TypeSupportInterface;

            typedef ConnectedClients_TypeSupportInterface * ConnectedClients_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClients_TypeSupportInterface> ConnectedClients_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ConnectedClients_TypeSupportInterface> ConnectedClients_TypeSupportInterface_out;


            class ConnectedClients_DataWriter;

            typedef ConnectedClients_DataWriter * ConnectedClients_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClients_DataWriter> ConnectedClients_DataWriter_var;
            typedef DDS_DCPSInterface_out < ConnectedClients_DataWriter> ConnectedClients_DataWriter_out;


            class ConnectedClients_DataReader;

            typedef ConnectedClients_DataReader * ConnectedClients_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClients_DataReader> ConnectedClients_DataReader_var;
            typedef DDS_DCPSInterface_out < ConnectedClients_DataReader> ConnectedClients_DataReader_out;


            class ConnectedClients_DataReaderView;

            typedef ConnectedClients_DataReaderView * ConnectedClients_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ConnectedClients_DataReaderView> ConnectedClients_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ConnectedClients_DataReaderView> ConnectedClients_DataReaderView_out;

            struct ConnectedClients_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ConnectedClients_, struct ConnectedClients_Seq_uniq_> ConnectedClients_Seq;
            typedef DDS_DCPSSequence_var < ConnectedClients_Seq> ConnectedClients_Seq_var;
            typedef DDS_DCPSSequence_out < ConnectedClients_Seq> ConnectedClients_Seq_out;

            class  ConnectedClients_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ConnectedClients_TypeSupportInterface_ptr _ptr_type;
                typedef ConnectedClients_TypeSupportInterface_var _var_type;

                static ConnectedClients_TypeSupportInterface_ptr _duplicate (ConnectedClients_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClients_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClients_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClients_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClients_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ConnectedClients_TypeSupportInterface () {};
                ~ConnectedClients_TypeSupportInterface () {};
            private:
                ConnectedClients_TypeSupportInterface (const ConnectedClients_TypeSupportInterface &);
                ConnectedClients_TypeSupportInterface & operator = (const ConnectedClients_TypeSupportInterface &);
            };

            class  ConnectedClients_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ConnectedClients_DataWriter_ptr _ptr_type;
                typedef ConnectedClients_DataWriter_var _var_type;

                static ConnectedClients_DataWriter_ptr _duplicate (ConnectedClients_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClients_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClients_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ConnectedClients_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ConnectedClients_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ConnectedClients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ConnectedClients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ConnectedClients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ConnectedClients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ConnectedClients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ConnectedClients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ConnectedClients_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ConnectedClients_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ConnectedClients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClients_& instance_data) = 0;

            protected:
                ConnectedClients_DataWriter () {};
                ~ConnectedClients_DataWriter () {};
            private:
                ConnectedClients_DataWriter (const ConnectedClients_DataWriter &);
                ConnectedClients_DataWriter & operator = (const ConnectedClients_DataWriter &);
            };

            class  ConnectedClients_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ConnectedClients_DataReader_ptr _ptr_type;
                typedef ConnectedClients_DataReader_var _var_type;

                static ConnectedClients_DataReader_ptr _duplicate (ConnectedClients_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClients_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClients_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConnectedClients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConnectedClients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConnectedClients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClients_& instance) = 0;

            protected:
                ConnectedClients_DataReader () {};
                ~ConnectedClients_DataReader () {};
            private:
                ConnectedClients_DataReader (const ConnectedClients_DataReader &);
                ConnectedClients_DataReader & operator = (const ConnectedClients_DataReader &);
            };

            class  ConnectedClients_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ConnectedClients_DataReaderView_ptr _ptr_type;
                typedef ConnectedClients_DataReaderView_var _var_type;

                static ConnectedClients_DataReaderView_ptr _duplicate (ConnectedClients_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ConnectedClients_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ConnectedClients_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ConnectedClients_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ConnectedClients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ConnectedClients_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ConnectedClients_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ConnectedClients_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ConnectedClients_& instance) = 0;

            protected:
                ConnectedClients_DataReaderView () {};
                ~ConnectedClients_DataReaderView () {};
            private:
                ConnectedClients_DataReaderView (const ConnectedClients_DataReaderView &);
                ConnectedClients_DataReaderView & operator = (const ConnectedClients_DataReaderView &);
            };
        }

    }

}

#endif
